#################################################################
#     ___                       __                 _            #
#    /___\_ __  _   ___  __    / _\ ___ _ ____   _(_) ___ ___   #
#   //  // '_ \| | | \ \/ /    \ \ / _ \ '__\ \ / / |/ __/ _ \  #
#  / \_//| | | | |_| |>  <     _\ \  __/ |   \ V /| | (_|  __/  #
#  \___/ |_| |_|\__, /_/\_\    \__/\___|_|    \_/ |_|\___\___|  #
#               |___/                                           #
#                                                               #
#                                                               #
#                  Module: as_onyx.inc                          #
#                  Auteur : ludo`                               #
#                  Site : www.zone-irc.com                      #
#                                                               #
#################################################################


#############################
#---------------------------#
# Configuration de SpamServ #
#---------------------------#
#############################
## Activation de SpampServ (0=dsactiv 1=activ)
set onyx(as:global:active) "1"
## Pseudo de SpampServ
set onyx(as:pseudo) "SpamServ"
## Identd de SpampServ
set onyx(as:ident) "spamserv"
## Realname de Aide
set onyx(as:real) "Bot anti-spam --> Onyx Service"
## Host de SpampServ
set onyx(as:host) "spamserv.domaine.tld"
## Mode de SpampServ
set onyx(as:mode) "+SBqW"
## Salon de SpampServ
set onyx(as:salon) "#AntiSpam"
## Mode de SpampServ sur le salon (q=owner a=protect o=op h=halfop v=voice)
set onyx(as:mode_pseudo) "+o"
## Mode du salon de SpampServ
set onyx(as:mode_salon) "+nts"
## Mode de SpamServ sur le salon scan (q=owner a=protect o=op h=halfop v=voice, laissez vide si aucun)
set onyx(as:mode_salon_scan) "+o"
#############################
# Configuration des actions #
#############################
## Niveau en cas de message 0:rien 1:avertissement 2:kill 3:gline 4:auto
set onyx(as:msg) "4"
## Message d'avertissement en cas de message
set onyx(as:avert_msg) "Pas de Spam !!!"
## Niveau en cas de notice 0:rien 1:avertissement 2:kill 3:gline 4:auto
set onyx(as:notice) "4"
## Message d'avertissement en cas de notice
set onyx(as:avert_notice) "Pas de Spam !!!"
## Niveau en cas d'invitation 0:rien 1:avertissement 2:kill 3:gline 4:auto
set onyx(as:invite) "1"
## Message d'avertissement en cas d'invitation
set onyx(as:avert_invite) "Pas de Spam !!!"
## Message lors d'un kill pour spam
set onyx(as:kill) "Pas de Spam !!!"
## Message lors d'un gline pour spam
set onyx(as:gline) "Pas de Spam !!!"
## Dure du gline
set onyx(as:temp) "3600"

#############################################################################################################################

###############
# Fichiers db #
###############
proc as:db {} {
  set nom_db "gestion.db detection.db exception.db salon.db"
  foreach nom_db2 $nom_db { 
    if {![file exists "db/as_onyx/$nom_db2"]} { set as_db [open db/as_onyx/$nom_db2 a+]; close $as_db }
  }
}

#############
# Lancement #
#############
proc as:lancement {} {
  global onyx
  ## Gestion
  catch {open db/as_onyx/gestion.db r} gestion_as
  while {![eof $gestion_as]} { 
    gets $gestion_as var
    if {$var!=""} { set [lindex $var 0] [lrange $var 1 end] } 
  }
  catch {close $gestion_as}
  ## Connextion
  if {$onyx(as:global:active)=="1"} {
    putdcc $onyx(idx) ":$onyx(link) NICK $onyx(as:pseudo) 1 [unixtime] $onyx(as:ident) $onyx(as:host) $onyx(link) :$onyx(as:real)"
    putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:pseudo) $onyx(as:mode)"
    putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $onyx(as:salon)"
    putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:salon) $onyx(as:mode_pseudo) $onyx(as:pseudo)"
    putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:salon) $onyx(as:mode_salon)"
    putdcc $onyx(idx) ":$onyx(as:pseudo) SQLINE $onyx(as:pseudo) :Rserv  Onyx Service"
    ## Salon scan
    catch {open db/as_onyx/salon.db r} scan
    while {![eof $scan]} { 
      gets $scan scan_chan
      if {$scan_chan!=""} { 
        putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $scan_chan"
	putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $scan_chan $onyx(as:mode_salon_scan) $onyx(as:pseudo)"
      } 
    }
    catch {close $scan}
    ##########
    catch {open db/as_onyx/salon.db r} liste_salon
    while {![eof $liste_salon]} {
      gets $liste_salon verif_salon
      if {$verif_salon!=""} { 
        set onyx(as:detect:salon) [lappend onyx(as:detect:salon) $verif_salon]
      }
    }
    catch {scan $liste_salon}
    ##########
    catch {open db/as_onyx/detection.db r} liste_mot
    while {![eof $liste_mot]} {
      gets $liste_mot verif_mot
      if {$verif_mot!=""} { 
        set onyx(as:detect:mot) [lappend onyx(as:detect:mot) $verif_mot]
      }
    }
    catch {scan $liste_mot}
    ##########
    catch {open db/as_onyx/exception.db r} liste_except
    while {![eof $liste_except]} {
      gets $liste_except verif_except
      if {$verif_except!=""} { 
        set onyx(as:detect:except) [lappend onyx(as:detect:except) $verif_except]
      }
    }
    catch {scan $liste_except}
  }
  ############
  if {$onyx(as:global:active)=="1"  && [string tolower $onyx(salon)]!=[string tolower $onyx(as:salon)]} {
    putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $onyx(salon)"
    putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(salon) $onyx(mode_bots_salon) $onyx(as:pseudo)"
  }
}

##########
# Divers #
##########
proc as:divers {arg} {
  global onyx
  set arg [join [split $arg]]
  set pour [lindex $arg 0]
  set idx2 [lindex $arg 1] 
  if {$pour=="help"} { putdcc $idx2 "SpamServ : 3.connexion_as 14(connexion de $onyx(as:pseudo)) 1| 4.deconnexion_as 14(dconnexion de $onyx(as:pseudo))" }
  if {$pour=="status"} {
    if {$onyx(as:global:active)=="1"} { putdcc $idx2 "1SpamServ (3Activ1) 3: 14Pseudo: $onyx(as:pseudo) Salon: $onyx(as:salon)" } else { putdcc $idx2 "1SpamServ (4Dsactiv1) 3: 14Pseudo: $onyx(as:pseudo) Salon: $onyx(as:salon)" }
  }
  if {$pour=="gestion"} {
    set sauv_as [open db/as_onyx/gestion.db w+]
    puts $sauv_as "onyx(as:global:active) $onyx(as:global:active)"
    puts $sauv_as "onyx(as:pseudo) $onyx(as:pseudo)"
    puts $sauv_as "onyx(as:ident) $onyx(as:ident)"
    puts $sauv_as "onyx(as:host) $onyx(as:host)"
    puts $sauv_as "onyx(as:real) $onyx(as:real)"
    puts $sauv_as "onyx(as:salon) $onyx(as:salon)"
    close $sauv_as
  }
  if {$pour=="chanlog"} {
    if {$onyx(as:global:active)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PART $onyx(salon) :Changement de salon" }
  }
}

###########
# as:load #
###########
proc as:load {} {
   global onyx
   putdcc $onyx(idx) ":$onyx(os:pseudo) PRIVMSG $onyx(salon) :Chargement de $onyx(as:pseudo) Bot anti-spam."
   as:db
   as:lancement
}

#############
# as:unload #
#############
proc as:unload {} {
   global onyx
   putdcc $onyx(idx) ":$onyx(os:pseudo) PRIVMSG $onyx(salon) :Dchargement de $onyx(as:pseudo)."
   putdcc $onyx(idx) ":$onyx(as:pseudo) UNSQLINE $onyx(as:pseudo)"
   putdcc $onyx(idx) ":$onyx(as:pseudo) QUIT :Dcharg de Onyx Service."
}

###################
# as:connexion_as #
###################
bind dcc n connexion_as as:connexion_as
proc as:connexion_as {nick idx arg} { 
   global onyx
   if {$onyx(as:global:active)=="0"} { 
     putdcc $idx "Connexion de $onyx(as:pseudo)"
     set onyx(as:global:active) 1
     set onyx(os:host:[string tolower $onyx(as:pseudo)]) $onyx(as:host)
     putdcc $onyx(idx) ":$onyx(link) NICK $onyx(as:pseudo) 1 [unixtime] $onyx(as:ident) $onyx(as:host) $onyx(link) :$onyx(as:real)"
     putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:pseudo) $onyx(as:mode)"
     putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $onyx(as:salon)"
     putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:salon) $onyx(as:mode_pseudo) $onyx(as:pseudo)"
     putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:salon) $onyx(as:mode_salon)"
     putdcc $onyx(idx) ":$onyx(as:pseudo) SQLINE $onyx(as:pseudo) :Rserv  Onyx Service"
     if {[string tolower $onyx(salon)]!=[string tolower $onyx(as:salon)]} {
       putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $onyx(salon)"
       putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(salon) $onyx(mode_bots_salon) $onyx(as:pseudo)"
     }
     ## Salon scan
     catch {open db/as_onyx/salon.db r} scan
     while {![eof $scan]} { 
       gets $scan scan_chan
       if {$scan_chan!=""} { 
         putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $scan_chan"
         putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $scan_chan $onyx(as:mode_salon_scan) $onyx(as:pseudo)"
       } 
     }
     catch {close $scan}
     onyx:gestion
   } else { putdcc $idx "$onyx(as:pseudo) est dj connect..." }
}

#####################
# as:deconnexion_as #
#####################
bind dcc n deconnexion_as as:deconnexion_as
proc as:deconnexion_as {nick idx arg} { 
   global onyx
   if {$onyx(as:global:active)=="1"} { 
     putdcc $idx "Dconnexion de $onyx(as:pseudo)"
     set onyx(as:global:active) 0
     unset onyx(os:host:[string tolower $onyx(as:pseudo)])
     putdcc $onyx(idx) ":$onyx(as:pseudo) UNSQLINE $onyx(as:pseudo)"
     putdcc $onyx(idx) ":$onyx(as:pseudo) QUIT :$onyx(raison)" 
     onyx:gestion
     } else { putdcc $idx "$onyx(as:pseudo) est dj dconnect..." }
}

###########
# as:help #
###########
proc as:help {arg} {
	global admin onyx
        set arg [join [split $arg]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set data [lindex $arg 2]
        set data2 [string tolower $data]
        set data3 [string tolower [lindex $arg 3]]
        if {$data2==""} {
         if {[info exists onyx(os:$vpseudo)] && [matchattr $onyx(os:$vpseudo) n]} {
         putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :SET Permet de configurer $onyx(as:pseudo)."
         putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :SALON Action sur les salons."
         putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :DETECT Action sur les dtections."
         putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :EXCEPT Action sur les exceptions."
         }
        } elseif {$data2=="salon" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :SALON Action sur les salons."
        } elseif {$data2=="salon" && $data3=="add"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) salon add #salon"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet d'ajouter un salon."
        } elseif {$data2=="salon" && $data3=="del"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) salon del #salon"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet d'effacer un salon."
        } elseif {$data2=="salon" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) salon list"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de voir la liste des salons."
        } elseif {$data2=="detect" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :DETECT Action sur les dtections."
        } elseif {$data2=="detect" && $data3=="add"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) detect add mot-cl"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet d'ajouter un mot  detecter."
        } elseif {$data2=="detect" && $data3=="del"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) detect del mot-cl"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet d'effacer un mot  detecter."
        } elseif {$data2=="detect" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) detect list"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de voir la liste des mots  detecter."
        } elseif {$data2=="except" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :EXCEPT Action sur les exceptions."
        } elseif {$data2=="except" && $data3=="add"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) except add mot-cl"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet d'ajouter un mot/salon/site  ne pas detecter."
        } elseif {$data2=="except" && $data3=="del"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) except del mot-cl"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet d'effacer un mot/salon/site  ne pas detecter."
        } elseif {$data2=="except" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) except list"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de voir la liste des exceptions."
        } elseif {$data2=="set" && $data3==""} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de voir la configuration possible de $onyx(as:pseudo)."
        } elseif {$data2=="set" && $data3=="pseudo"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set pseudo nouveau_pseudo"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de changer le pseudo du bot."
        } elseif {$data2=="set" && $data3=="ident"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set ident nouveau_ident"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de changer l'ident du bot."
        } elseif {$data2=="set" && $data3=="host"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set host nouveau_host"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de changer l'host du bot."
        } elseif {$data2=="set" && $data3=="realname"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set realname nouveau_realname"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de changer le realname du bot."
        } elseif {$data2=="set" && $data3=="salon"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set salon #nouveau_salon"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de changer le salon principal du bot."
        } elseif {$data2=="set" && $data3=="list"} {
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Syntax: /msg $onyx(as:pseudo) set list"
            putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Permet de montrer les fixations actuelles du bot."
        } else { putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :Aucune aide disponible sur cette commande." }
}

##########
# as:set #
##########
proc as:set {arg} {
	global onyx
	set arg [join [split $arg]]
	set pseudo [lindex $arg 0]
	set vpseudo [string tolower $pseudo]
	set data [string tolower [lindex $arg 2]]
	set data2 [lindex $arg 3]
	set vdata2 [string tolower $data2]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) n]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Votre  level est insuffisant pour utilser cette commande."; return 0 }
	if {$data==""} { 
          putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :PSEUDO Permet de changer le pseudo du bot."
          putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :IDENT Permet de changer l'ident du bot."
          putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :HOST Permet de changer l'host du bot."
          putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :REALNAME Permet de changer le realname du bot."
          putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :SALON Permet de changer le salon principal du bot."
          putdcc $onyx(idx) ":$onyx(as:pseudo) Notice $pseudo :LIST Permet de montrer les fixations actuelles du bot."
          return 0 
	}
	if {$data=="pseudo"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Set pseudo : /msg $onyx(as:pseudo) set pseudo nouveau_pseudo"; return 0 }
          if {$vdata2==[string tolower $onyx(as:pseudo)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Pseudo Identique."; return 0 }
          set new_pseudo $data2
          set onyx(verif:pseudo_bot) "as $new_pseudo $pseudo 0"
          putdcc $onyx(idx) ":$onyx(as:pseudo) WHO $new_pseudo"
        }
	if {$data=="ident"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Set ident : /msg $onyx(as:pseudo) set ident nouveau_ident"; return 0 }
          putdcc $onyx(idx) ":$onyx(as:pseudo) CHGIDENT $onyx(as:pseudo) $data2"
          set onyx(as:ident) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Changement de l'ident russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set ident$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="host"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Set host : /msg $onyx(as:pseudo) set host nouveau_host"; return 0 }
          putdcc $onyx(idx) ":$onyx(as:pseudo) CHGHOST $onyx(as:pseudo) $data2"
          set onyx(os:host:[string tolower $onyx(as:pseudo)]) $data2
          set onyx(as:host) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Changement de l'host russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set host$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="realname"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Set realname : /msg $onyx(as:pseudo) set realname nouveau_realname"; return 0 }
          putdcc $onyx(idx) ":$onyx(as:pseudo) CHGNAME $onyx(as:pseudo) [lrange $arg 3 end]"
          set onyx(as:real) [lrange $arg 3 end]
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Changement du realname russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set realname$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="salon"} {
          if {$data2==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Set salon : /msg $onyx(as:pseudo) set salon #nouveau_salon"; return 0 }
          if {[string index $data2 0]!="#"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Vous avez oublier le # devant le nouveau salon."; return 0 }
          if {$vdata2==[string tolower $onyx(as:salon)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Salon Identique."; return 0 } 
          putdcc $onyx(idx) ":$onyx(as:pseudo) PART $onyx(as:salon) :Changement de salon"
          set onyx(as:salon) $data2
          onyx:gestion
          putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $onyx(as:salon)"
          putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $onyx(as:salon) $onyx(as:mode_pseudo) $onyx(as:pseudo)"
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Changement du salon russi."
          if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Set salon$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
	if {$data=="list"} {
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Pseudo: $onyx(as:pseudo)"
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Ident: $onyx(as:ident)"
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Host: $onyx(as:host)"
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Realname: $onyx(as:real)"
          putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Salon: $onyx(as:salon)"
        }
}

############
# as:salon #
############
proc as:salon {arg} {
	global onyx
	set arg [join [split $arg]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set cmd [lindex $arg 2]
        set vcmd [string tolower $cmd]
        set data [lindex $arg 3]
        set vdata [string tolower $data]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) m]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Votre level est insuffisant pour utilser cette commande."; return 0 }
        if {$vcmd=="add"} { 
	  if {$data=="" || [string index $data 0]!="#"} { putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :Commande Salon add : /msg $onyx(as:pseudo) salon add #salon"; return 0 }
	  set stop 0
	  catch {open db/as_onyx/salon.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	      if {$verif==$vdata} { 
                putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data est dj dans la liste des salons."
                set stop 1
                break 
	      }
	  }
	  catch {scan $liste}
	  if {$stop==1} { return 0 }
	  set scan [open db/as_onyx/salon.db a]
	  puts $scan "$vdata"
	  close $scan
          ##########
          if {[info exists onyx(as:detect:salon)] } { unset onyx(as:detect:salon) }
	  catch {open db/as_onyx/salon.db r} liste_salon
	  while {![eof $liste_salon]} {
	    gets $liste_salon verif_salon
	      if {$verif_salon!=""} { 
                set onyx(as:detect:salon) [lappend onyx(as:detect:salon) $verif_salon]
	      }
	  }
	  catch {scan $liste_salon}
	  putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data vient d'tre ajout  la liste des salons."
          if {$vdata!=[string tolower $onyx(as:salon)]} { 
	    putdcc $onyx(idx) ":$onyx(as:pseudo) JOIN $data"
	    putdcc $onyx(idx) ":$onyx(as:pseudo) MODE $data $onyx(as:mode_salon_scan) $onyx(as:pseudo)"
          }
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Salon add$onyx(os:couleur_deco) : $onyx(os:couleur_txt)$data par $pseudo" }
        }
        if {$vcmd=="del"} { 
	  if {$data=="" || [string index $data 0]!="#"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Salon del : /msg $onyx(as:pseudo) salon del #salon"; return 0 }
	  set stop 0
	  catch {open db/as_onyx/salon.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	    if {$verif==$vdata} { set stop 1 }
	    if {$verif!=$vdata && $verif!=""} { lappend salon "$verif" }
	  }
	  catch {close $liste}
	  if {$stop==0} { 
	    putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data n'est pas dans la liste des salons." 
	    return 0 
	  } else {
	    if [info exists salon] {
	    set del [open db/as_onyx/salon.db w+]
	    foreach scanchan $salon { puts $del "$scanchan" }
	    close $del
	  } else {
	    set del [open db/as_onyx/salon.db w+]
	    close $del
	  }
          ##########
          if {[info exists onyx(as:detect:salon)] } { unset onyx(as:detect:salon) }
	  catch {open db/as_onyx/salon.db r} liste_salon
	  while {![eof $liste_salon]} {
	    gets $liste_salon verif_salon
	      if {$verif_salon!=""} { set onyx(as:detect:salon) [lappend onyx(as:detect:salon) $verif_salon] }
	  }
	  catch {scan $liste_salon}
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :$data vient d'tre supprim de la liste des salons."
          if {$vdata!=[string tolower $onyx(as:salon)]} { 
	    putdcc $onyx(idx) ":$onyx(as:pseudo) PART $data"
          }
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Salon del$onyx(os:couleur_deco) : $onyx(os:couleur_txt)$data par $pseudo" }
          }
        }
        if {$vcmd=="list"} {
	  set num 0
	  catch {open db/as_onyx/salon.db r} liste
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :1,1---------- 0Liste des salons 1----------"
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :"
	  while {![eof $liste]} {
	    gets $liste chan
	    if {$chan!=""} { 
              incr num 1
              putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo : 1 \[03 $num 01\] 01 $chan" 
	    } 
	  }
	  catch {close $liste}
	  if {$num=="0"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Aucun Salon." }
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Salon list$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
}

#############
# as:detect #
#############
proc as:detect {arg} {
	global onyx
	set arg [join [split $arg]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set cmd [lindex $arg 2]
        set vcmd [string tolower $cmd]
        set data [lindex $arg 3]
        set vdata [string tolower $data]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) m]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Votre level est insuffisant pour utilser cette commande."; return 0 }
        if {$vcmd=="add"} { 
	  if {$data==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Detect add : /msg $onyx(as:pseudo) detect add mot-cl"; return 0 }
	  set stop 0
	  catch {open db/as_onyx/detection.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	      if {$verif==$vdata} { 
                putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data est dj dans la liste des mots  detecter."
                set stop 1
                break 
	      }
	  }
	  catch {scan $liste}
	  if {$stop==1} { return 0 }
	  set scan_mot [open db/as_onyx/detection.db a]
	  puts $scan_mot "$vdata"
	  close $scan_mot
          ##########
          if {[info exists onyx(as:detect:mot)] } { unset onyx(as:detect:mot) }
	  catch {open db/as_onyx/detection.db r} liste_detect
	  while {![eof $liste_detect]} {
	    gets $liste_detect verif_mot
	      if {$verif_mot!=""} {
                set onyx(as:detect:mot) [lappend onyx(as:detect:mot) $verif_mot]
	      }
	  }
	  catch {scan $liste_detect}
	  putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data vient d'tre ajout  la liste des mots  detecter."
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Detect add$onyx(os:couleur_deco) : $onyx(os:couleur_txt)$data par $pseudo" }
        }
        if {$vcmd=="del"} { 
	  if {$data==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Detect del : /msg $onyx(as:pseudo) detect del mot-cl"; return 0 }
	  set stop 0
	  catch {open db/as_onyx/detection.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	    if {$verif==$vdata} { set stop 1 }
	    if {$verif!=$vdata && $verif!=""} { lappend mot "$verif" }
	  }
	  catch {close $liste}
	  if {$stop==0} { 
	    putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data n'est pas dans la liste des mots  detecter." 
	    return 0 
	  } else {
	    if [info exists mot] {
	    set del [open db/as_onyx/detection.db w+]
	    foreach scanmot $mot { puts $del "$scanmot" }
	    close $del
	  } else {
	    set del [open db/as_onyx/detection.db w+]
	    close $del
	  }
          ##########
          if {[info exists onyx(as:detect:mot)] } { unset onyx(as:detect:mot) }
	  catch {open db/as_onyx/detection.db r} liste_detect
	  while {![eof $liste_detect]} {
	    gets $liste_detect verif_mot
	      if {$verif_mot!=""} { set onyx(as:detect:mot) [lappend onyx(as:detect:mot) $verif_mot] }
	  }
	  catch {scan $liste_detect}
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :$data vient d'tre supprim de la liste des mots  detecter."
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Detect del$onyx(os:couleur_deco) : $onyx(os:couleur_txt)$data par $pseudo" }
          }
        }
        if {$vcmd=="list"} {
	  set num 0
	  catch {open db/as_onyx/detection.db r} liste
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :1,1---------- 0Liste des mots  detecter 1----------"
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :"
	  while {![eof $liste]} {
	    gets $liste mot
	    if {$mot!=""} { 
              incr num 1

              putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo : 1 \[03 $num 01\] 01 $mot" 
	    } 
	  }
	  catch {close $liste}
	  if {$num=="0"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Aucun mot." }
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Detect list$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
}

#############
# as:except #
#############
proc as:except {arg} {
	global onyx
	set arg [join [split $arg]]
        set pseudo [lindex $arg 0]
        set vpseudo [string tolower $pseudo]
        set cmd [lindex $arg 2]
        set vcmd [string tolower $cmd]
        set data [lindex $arg 3]
        set vdata [string tolower $data]
        if {![info exists onyx(os:$vpseudo)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Auth : /msg $onyx(os:pseudo) auth pseudo motdepasse"; return 0 }
        if {![matchattr $onyx(os:$vpseudo) m]} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Votre level est insuffisant pour utilser cette commande."; return 0 }
        if {$vcmd=="add"} { 
	  if {$data==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Except add : /msg $onyx(as:pseudo) except add mot-cl"; return 0 }
	  set stop 0
	  catch {open db/as_onyx/exception.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	      if {$verif==$vdata} { 
                putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data est dj dans la liste des exceptions."
                set stop 1
                break 
	      }
	  }
	  catch {scan $liste}
	  if {$stop==1} { return 0 }
	  set scan_mot [open db/as_onyx/exception.db a]
	  puts $scan_mot "$vdata"
	  close $scan_mot
          ##########
          if {[info exists onyx(as:detect:except)] } { unset onyx(as:detect:except) }
	  catch {open db/as_onyx/exception.db r} liste_except
	  while {![eof $liste_except]} {
	    gets $liste_except verif_except
	      if {$verif_except!=""} { 
                set onyx(as:detect:except) [lappend onyx(as:detect:except) $verif_except]
	      }
	  }
	  catch {scan $liste_except}
	  putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data vient d'tre ajout  la liste des exceptions."
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Except add$onyx(os:couleur_deco) : $onyx(os:couleur_txt)$data par $pseudo" }
        }
        if {$vcmd=="del"} { 
	  if {$data==""} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Commande Except del : /msg $onyx(as:pseudo) except del mot-cl"; return 0 }
	  set stop 0
	  catch {open db/as_onyx/exception.db r} liste
	  while {![eof $liste]} {
	    gets $liste verif
	    if {$verif==$vdata} { set stop 1 }
	    if {$verif!=$vdata && $verif!=""} { lappend exception "$verif" }
	  }
	  catch {close $liste}
	  if {$stop==0} { 
	    putdcc $onyx(idx) ":$onyx(os:pseudo) NOTICE $pseudo :$data n'est pas dans la liste des exceptions." 
	    return 0 
	  } else {
	    if [info exists exception] {
	    set del [open db/as_onyx/exception.db w+]
	    foreach scanexcept $exception { puts $del "$scanexcept" }
	    close $del
	  } else {
	    set del [open db/as_onyx/detection.db w+]
	    close $del
	  }
          ##########
          if {[info exists onyx(as:detect:except)] } { unset onyx(as:detect:except) }
	  catch {open db/as_onyx/exception.db r} liste_except
	  while {![eof $liste_except]} {
	    gets $liste_except verif_except
	      if {$verif_except!=""} { set onyx(as:detect:except) [lappend onyx(as:detect:except) $verif_except] }
	  }
	  catch {scan $liste_except}
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :$data vient d'tre supprim de la liste des exceptions."
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Except del$onyx(os:couleur_deco) : $onyx(os:couleur_txt)$data par $pseudo" }
          }
        }
        if {$vcmd=="list"} {
	  set num 0
	  catch {open db/as_onyx/exception.db r} liste
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :1,1---------- 0Liste des exceptions 1----------"
	  putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :"
	  while {![eof $liste]} {
	    gets $liste exception
	    if {$exception!=""} { 
              incr num 1
              putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo : 1 \[03 $num 01\] 01 $exception" 
	    } 
	  }
	  catch {close $liste}
	  if {$num=="0"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $pseudo :Aucune exception." }
	  if {$onyx(os:console)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Except list$onyx(os:couleur_deco) : $onyx(os:couleur_txt)utilis par $pseudo" }
        }
}

############
# as:event #
############
proc as:event {arg} {
   global egg onyx admin
   set arg [join [split $arg]]
switch -exact [lindex $arg 1] {
  "PRIVMSG" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set pour [lindex $arg 2]
    set vpour [string tolower $pour]
    set commande [string tolower [string trim [lindex $arg 3] :]]
    set commande2 [string trim $commande $onyx(prefix)]
    set data [lrange $arg 3 end]
    if {$vpour==[string tolower $onyx(as:pseudo)] || $vpour==[string tolower $onyx(as:salon)]} {
      if {[string tolower $onyx(as:salon)]==$onyx(salon2) && $vpour!=[string tolower $onyx(as:pseudo)]} { return 0 } 
      if {$commande2=="help"} { if {[global:flood "as $pseudo"]!="ok"} { return 0 }; as:help "$pseudo $data" }
      if {$commande2=="set"} { if {[global:flood "as $pseudo"]!="ok"} { return 0 }; as:set "$pseudo $data" }
      if {$commande2=="salon"} { if {[global:flood "as $pseudo"]!="ok"} { return 0 }; as:salon "$pseudo $data" }
      if {$commande2=="detect"} { if {[global:flood "as $pseudo"]!="ok"} { return 0 }; as:detect "$pseudo $data" }
      if {$commande2=="except"} { if {[global:flood "as $pseudo"]!="ok"} { return 0 }; as:except "$pseudo $data" }
    }
    set temp [join [string trim [lrange $arg 3 end] :]]
    set phrase [string tolower [string trim $temp ]]
    ## Scan les salons mis
    set chanprivscan 0
    if {[info exists onyx(as:detect:salon)]} {
      foreach detect_salon $onyx(as:detect:salon) { 
        if {[string match *$detect_salon* $vpour] || [info exists onyx(bot:$vpour)]} { set chanprivscan 1 } 
      }
    }
    ## scan les mots 'site, salons, etc...) sans action dessus
    set exception 0
    if {[info exists onyx(as:detect:except)]} {
      foreach detect_except $onyx(as:detect:except) { 
        if {[string match *$detect_except* $phrase]} { set exception 1 } 
      }
    }
    ## Scan les mots a detecter
    set detection 0
    if {[info exists onyx(as:detect:mot)]} {
      foreach detect_mot $onyx(as:detect:mot) { 
        if {[string match *$detect_mot* $phrase]} { set detection 1 } 
      }
    }
    ## Action
    if {$chanprivscan=="1" && $exception=="0" && $detection=="1"} {
      if {[info exists onyx(os:$vpseudo)]} { return 0 }
      if {[info exists onyx(os:protect:$onyx(os:host:$vpseudo))]} { return 0 }
      if {$onyx(os:console)=="1"} {
        if {[info exists onyx(bot:$vpour)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Spam message priv$onyx(os:couleur_deco) : $onyx(os:couleur_txt)par $pseudo  $pour : $phrase " } else { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Spam message salon$onyx(os:couleur_deco) : $onyx(os:couleur_txt)par $pseudo sur $pour : $phrase" }
      }
      if {[info exists onyx(as:spam:$vpseudo)]} { incr onyx(as:spam:$vpseudo) 1 } else { set onyx(as:spam:$vpseudo) 1 }
      if {$onyx(as:msg)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $vpseudo :$onyx(as:avert_notice)"; unset onyx(as:spam:$vpseudo) }
      if {$onyx(as:msg)=="2"} { 
        putdcc $onyx(idx) ":$onyx(as:pseudo) KILL $vpseudo :$onyx(as:kill)"
        unset onyx(as:spam:$vpseudo)
      }
      if {$onyx(as:msg)=="3"} { putdcc $onyx(idx) ":$onyx(link) TKL + G * $onyx(os:host:$vpseudo) $onyx(as:pseudo) [expr [unixtime] + $onyx(as:temp)] [unixtime] : $onyx(as:gline)" }
      if {$onyx(as:msg)=="4"} {
        if {$onyx(as:spam:$vpseudo)!="7"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $vpseudo :$onyx(as:avert_msg)" }
        if {$onyx(as:spam:$vpseudo)=="4"} {
          putdcc $onyx(idx) ":$onyx(as:pseudo) KILL $vpseudo :$onyx(as:kill)"
        }
        if {$onyx(as:spam:$vpseudo)=="7"} { 
          putdcc $onyx(idx) ":$onyx(link) TKL + G * $onyx(os:host:$vpseudo) $onyx(as:pseudo) [expr [unixtime] + $onyx(as:temp)] [unixtime] : $onyx(as:gline)" 
          unset onyx(as:spam:$vpseudo)
          }
      }
    }
    }
  "NOTICE" 
    {
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set pour [lindex $arg 2]
    set vpour [string tolower $pour]
    set action_notice [lrange $arg 3 end]
    set de [lindex $arg 4]
    set vde [string tolower $de]
    set temp [join [string trim [lrange $arg 3 end] :]]
    set phrase [string tolower [string trim $temp ]]
    ## Scan les salons mis
    set chanprivscan 0
    if {[info exists onyx(as:detect:salon)]} {
      foreach detect_salon $onyx(as:detect:salon) { 
        if {[string match *$detect_salon* $vpour] || [info exists onyx(bot:$vpour)]} { set chanprivscan 1 } 
      }
    }
    ## scan les mots 'site, salons, etc...) sans action dessus
    set exception 0
    if {[info exists onyx(as:detect:except)]} {
      foreach detect_except $onyx(as:detect:except) { 
        if {[string match *$detect_except* $phrase]} { set exception 1 } 
      }
    }
    ## Scan les mots a detecter
    set detection 0
    if {[info exists onyx(as:detect:mot)]} {
      foreach detect_mot $onyx(as:detect:mot) { 
        if {[string match *$detect_mot* $phrase]} { set detection 1 } 
      }
    }
    ## Action
    if {$chanprivscan=="1" && $exception=="0" && $detection=="1"} {
      if {[info exists onyx(os:$vpseudo)]} { return 0 }
      if {[info exists onyx(os:protect:$onyx(os:host:$vpseudo))]} { return 0 }
      if {$onyx(os:console)=="1"} { 
        if {[info exists onyx(bot:$vpour)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Spam notice priv$onyx(os:couleur_deco) : $onyx(os:couleur_txt)par $pseudo  $pour : $phrase" } else { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Spam notice salon$onyx(os:couleur_deco) : $onyx(os:couleur_txt)par $pseudo sur $pour : $phrase" }
      }
      if {[info exists onyx(as:spam:$vpseudo)]} { incr onyx(as:spam:$vpseudo) 1 } else { set onyx(as:spam:$vpseudo) 1 }
      if {$onyx(as:notice)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $vpseudo :$onyx(as:avert_notice)" }
      if {$onyx(as:notice)=="2"} { putdcc $onyx(idx) ":$onyx(as:pseudo) KILL $vpseudo :$onyx(as:kill)" }
      if {$onyx(as:notice)=="3"} { putdcc $onyx(idx) ":$onyx(link) TKL + G * $onyx(os:host:$vpseudo) $onyx(as:pseudo) [expr [unixtime] + $onyx(as:temp)] [unixtime] : $onyx(as:gline)" }
      if {$onyx(as:notice)=="4"} {
        if {$onyx(as:spam:$vpseudo)!="7"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $vpseudo :$onyx(as:avert_notice)" }
        if {$onyx(as:spam:$vpseudo)=="4"} { putdcc $onyx(idx) ":$onyx(as:pseudo) KILL $vpseudo :$onyx(as:kill)" }
        if {$onyx(as:spam:$vpseudo)=="7"} { 
          putdcc $onyx(idx) ":$onyx(link) TKL + G * $onyx(os:host:$vpseudo) $onyx(as:pseudo) [expr [unixtime] + $onyx(as:temp)] [unixtime] : $onyx(as:gline)" 
          unset onyx(as:spam:$vpseudo)
          }
      }
    }
    }
  "INVITE" 
    { 
    set pseudo [string trim [lindex $arg 0] :]
    set vpseudo [string tolower $pseudo]
    set pour [lindex $arg 2]
    set vpour [string tolower $pour]
    set temp [join [string trim [lrange $arg 3 end] :]]
    set phrase [string tolower [string trim $temp ]]
    ## scan les mots 'site, salons, etc...) sans action dessus
    set exception 0
    catch {open db/as_onyx/exception.db r} liste_ex
    while {![eof $liste_ex]} {
      gets $liste_ex exc
      if {$exc!=""} { 
      if {[string match *$exc* $phrase]} { set exception 1 }
      } 
    }
    catch {close $liste_ex}
    ## Scan les mots a detecter
    set detection 0
    catch {open db/as_onyx/detection.db r} liste_de
    while {![eof $liste_de]} {
      gets $liste_de det
      if {$det!=""} { 
      if {[string match *$det* $phrase]} { set detection 1 }
      } 
    }
    catch {close $liste_de}
    ## Action
    if {$exception=="0" && $detection=="1"} {
      if {[info exists onyx(os:$vpseudo)]} { return 0 }
      if {[info exists onyx(os:protect:$onyx(os:host:$vpseudo))]} { return 0 }
      if {$onyx(os:console)=="1"} { 
        if {[info exists onyx(bot:$vpour)]} { putdcc $onyx(idx) ":$onyx(as:pseudo) PRIVMSG $onyx(salon) :$onyx(os:couleur_evmt)Spam invite$onyx(os:couleur_deco) : $onyx(os:couleur_txt)par $pseudo sur $pour pour $phrase" }
      }
      if {[info exists onyx(as:spam:$vpseudo)]} { incr onyx(as:spam:$vpseudo) 1 } else { set onyx(as:spam:$vpseudo) 1 }
      if {$onyx(as:invite)=="1"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $vpseudo :$onyx(as:avert_invite)" }
      if {$onyx(as:invite)=="2"} { putdcc $onyx(idx) ":$onyx(as:pseudo) KILL $vpseudo :$onyx(as:kill)" }
      if {$onyx(as:invite)=="3"} { putdcc $onyx(idx) ":$onyx(link) TKL + G * $onyx(os:host:$vpseudo) $onyx(as:pseudo) [expr [unixtime] + $onyx(as:temp)] [unixtime] : $onyx(as:gline)" }
      if {$onyx(as:invite)=="4"} {
        if {$onyx(as:spam:$vpseudo)!="7"} { putdcc $onyx(idx) ":$onyx(as:pseudo) NOTICE $vpseudo :$onyx(as:avert_invite)" }
        if {$onyx(as:spam:$vpseudo)=="4"} { putdcc $onyx(idx) ":$onyx(as:pseudo) KILL $vpseudo :$onyx(as:kill)" }
        if {$onyx(as:spam:$vpseudo)=="7"} { 
          putdcc $onyx(idx) ":$onyx(link) TKL + G * $onyx(os:host:$vpseudo) $onyx(as:pseudo) [expr [unixtime] + $onyx(as:temp)] [unixtime] : $onyx(as:gline)" 
          unset onyx(as:spam:$vpseudo)
          }
      }
    }
    }
  "NICK" 
    {
    set vpseudo [string tolower [string trim [lindex $arg 0] :]]
    set vnewpseudo [string tolower [lindex $arg 2]]
    if {[info exists onyx(as:spam:$vpseudo)] && $vpseudo!=$vnewpseudo} { 
      set onyx(as:spam:$vnewpseudo) $onyx(as:spam:$vpseudo); unset onyx(as:spam:$vpseudo)
    }
    }
  "KILL" 
    { 
    set pseudo [lindex $arg 2]
    if {$pseudo==$onyx(as:pseudo)} { as:lancement }
    }
  "QUIT" 
    {
    set vpseudo [string tolower [string trim [lindex $arg 0] :] ]
    if {[info exists onyx(as:spam:$vpseudo)]} { unset onyx(as:spam:$vpseudo) }
    }
  }
}

##########
# as:web #
##########
proc as:web {arg} {
   global onyx 
   set htmlpage [lindex $arg 0]
   set num_menu [lindex $arg 1]
   puts $htmlpage "<script language=\"javascript\" type=\"text/javascript\">"
   puts $htmlpage "function asmenu(id) {"
   puts $htmlpage "  if (id == 1) {"
   puts $htmlpage "   document.getElementById('asmenu2').style.display='none';"
   puts $htmlpage "   document.getElementById('asmenu3').style.display='none';"
   puts $htmlpage "   document.getElementById('asmenu1').style.display='block';"
   puts $htmlpage "  }"
   puts $htmlpage "  if (id == 2) {"
   puts $htmlpage "   document.getElementById('asmenu1').style.display='none';"
   puts $htmlpage "   document.getElementById('asmenu3').style.display='none';"
   puts $htmlpage "   document.getElementById('asmenu2').style.display='block';"
   puts $htmlpage "  }"
   puts $htmlpage "  if (id == 3) {"
   puts $htmlpage "   document.getElementById('asmenu1').style.display='none';"
   puts $htmlpage "   document.getElementById('asmenu2').style.display='none';"
   puts $htmlpage "   document.getElementById('asmenu3').style.display='block';"
   puts $htmlpage "  }"
   puts $htmlpage "}"
   puts $htmlpage "</script>"
   puts $htmlpage "<table width=\"85%\" align=\"center\" id=\"menu$num_menu\" style=\"display: none; text-align: center\"><tr><td>"
   puts $htmlpage "<table width=\"100%\" align=\"center\"><tr>"
   puts $htmlpage "<td valign=\"top\">"
   puts $htmlpage "<table width=\"100%\" align=\"center\"><tr>"
   puts $htmlpage "<td width=\"60%\" valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Pseudo du SpamServ :</font> $onyx(as:pseudo)<br>"
   puts $htmlpage "<font class=\"text1\">Ident du SpamServ :</font> $onyx(as:ident)<br>"
   puts $htmlpage "<font class=\"text1\">Host du SpamServ :</font> $onyx(as:host)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du SpamServ :</font> $onyx(as:mode)<br>"
   puts $htmlpage "<font class=\"text1\">Realname du SpamServ :</font> $onyx(as:real)<br>"
   puts $htmlpage "<font class=\"text1\">Salon du SpamServ :</font> $onyx(as:salon)<br>"
   puts $htmlpage "<font class=\"text1\">Modes du salon :</font> $onyx(as:mode_salon)<br>"
   puts $htmlpage "<font class=\"text1\">Mode sur le salon :</font> $onyx(as:mode_pseudo)<br>"
   if {$onyx(as:global:active)=="1"} { puts $htmlpage "<font class=\"text1\">SpamServ activ :</font> Oui<br>" } else { puts $htmlpage "<font class=\"text1\">SpamServ activ :</font> Non<br>" }
   puts $htmlpage "</td><td valign=\"top\">"
   puts $htmlpage "<font class=\"text1\">Niveau message :</font> $onyx(as:msg)<br>"
   puts $htmlpage "<font class=\"text1\">Avertissement :</font> $onyx(as:avert_msg)<br>"
   puts $htmlpage "<font class=\"text1\">Niveau notice :</font> $onyx(as:notice)<br>"
   puts $htmlpage "<font class=\"text1\">Avertissement :</font> $onyx(as:avert_notice)<br>"
   puts $htmlpage "<font class=\"text1\">Niveau invite :</font> $onyx(as:invite)<br>"
   puts $htmlpage "<font class=\"text1\">Avertissement :</font> $onyx(as:avert_invite)<br>"
   puts $htmlpage "<font class=\"text1\">Message lors d'un kill :</font> $onyx(as:kill)<br>"
   puts $htmlpage "<font class=\"text1\">Message lors d'un gline :</font> $onyx(as:gline)<br>"
   puts $htmlpage "<font class=\"text1\">Dure du gline :</font> $onyx(as:temp)<br>"
   puts $htmlpage "</td></tr></table>"
   puts $htmlpage "<br><center>0:rien &nbsp;&nbsp; 1:avertissement &nbsp;&nbsp; 2:kill &nbsp;&nbsp; 3:gline &nbsp;&nbsp; 4:auto</center>"
   puts $htmlpage "</td></tr><tr><td valign=\"top\" align=\"center\">"
   puts $htmlpage "<br><table width=\"100%\" class=\"tab\" align=\"center\"><tr><td align=\"center\">"
   puts $htmlpage "<a href=\"#\" onclick=\"asmenu('1')\">Salons</a>&nbsp;&nbsp;"
   puts $htmlpage "<a href=\"#\" onclick=\"asmenu('2')\">Detection</a>&nbsp;&nbsp;"
   puts $htmlpage "<a href=\"#\" onclick=\"asmenu('3')\">Exception</a>&nbsp;&nbsp;"
   puts $htmlpage "</td></tr></table><br>"
   puts $htmlpage "<span id=\"asmenu1\" style=\"display: none; text-align: center\">"
   puts $htmlpage "<font class=\"text2\" size=\"+2\">Liste des salons</font><br><br>"
   set num 0
   catch {open db/as_onyx/salon.db r} liste_salon
   while {![eof $liste_salon]} {
     gets $liste_salon salon_htm
     if {$salon_htm!=""} { incr num 1; puts $htmlpage "<font class=\"text2\"><b>$salon_htm</b></font><br>" }
   }
   catch {close $liste_salon}
   if {$num=="0"} { puts $htmlpage "Aucun salon<br>" }
   puts $htmlpage "<br>"
   puts $htmlpage "</span>"
   puts $htmlpage "<span id=\"asmenu2\" style=\"display: none; text-align: center\">"
   puts $htmlpage "<font class=\"text2\" size=\"+2\">Liste des detections</font><br><br>"
   set num 0
   catch {open db/as_onyx/detection.db r} liste_detect
   while {![eof $liste_detect]} {
     gets $liste_detect detect_htm
     if {$detect_htm!=""} { incr num 1; puts $htmlpage "<font class=\"text2\">$detect_htm</font><br>" }
   }
   catch {close $liste_detect}
   if {$num=="0"} { puts $htmlpage "Aucune detection<br>" }
   puts $htmlpage "<br>"
   puts $htmlpage "</span>"
   puts $htmlpage "<span id=\"asmenu3\" style=\"display: none; text-align: center\">"
   puts $htmlpage "<font class=\"text2\" size=\"+2\">Liste des exceptions</font><br><br>"
   set num 0
   catch {open db/as_onyx/exception.db r} liste_except
   while {![eof $liste_except]} {
     gets $liste_except except_htm
     if {$except_htm!=""} { incr num 1; puts $htmlpage "<font class=\"text2\">$except_htm</font><br>" } 
   }
   catch {close $liste_except}
   if {$num=="0"} { puts $htmlpage "Aucune exception<br>" }
   puts $htmlpage "<br>"
   puts $htmlpage "</span>"
   puts $htmlpage "</td></tr></table>"
   puts $htmlpage "</td></tr></table>"   
}